#!/opt/gawk/bin -f

# Generate random clauses over f:2, i:1, 0, X, Y, Z

function printterm(depth)
{
  tmp = rand();

  if(depth == 0 || tmp > 0.8)
    {
      tmp = rand();
      if(tmp < 0.25)
	{
	  printf("0");
	}
      else if(tmp < 0.5)
	{
	  printf("X");
	}
      else if(tmp < 0.75)
	{
	printf("Y");
	}
      else 
	{
	  printf("Z");
	}
    }
  else
    {
      tmp = rand();
      if(tmp < 0.5)
	{
	  printf("i(");
	  printterm(depth-1);
	  printf(")");
	}
      else
	{
	  printf("f(");	  
	  printterm(depth-1);
	  printf(",");
	  printterm(depth-1);
	  printf(")");
	}
    }
}


BEGIN{
  if(!ARGV[2])
    {
      print "Usage: termgen.awk <depth> <number>" > "/dev/stderr";
      exit 1;
    }
  depth =  ARGV[1];
  number = ARGV[2];
  ARGV[1] = "";
  ARGV[2] = "";

  srand();
  i=0;
  while(i<number)
    {
      printterm(depth);
      printf("=");
      printterm(depth);
      print ".";
      i++;
    }
}

